<?xml version="1.0" encoding="UTF-8"?>
<!--
   ASF (Activities: Sequential to Flow) WS-BPEL mutation operator

   Exchanges an activity sequence with a flow of concurrent activities.

   Antonio García Domínguez <antonio.garciadominguez@uca.es>
-->
<xsl:stylesheet
    version="2.0"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:f="java:es.uca.webservices.bpel.util.FuncionesXPath"
    xmlns:conv="java:es.uca.webservices.xpath.ConversorXMLXPath"
    xmlns:uca="http://www.uca.es/xpath/2007/11"
    xmlns:bpel="http://docs.oasis-open.org/wsbpel/2.0/process/executable">

  <xsl:import href="es/uca/webservices/mutants/operators/op-base.xsl"/>

  <xsl:param name="action" as="xs:string"/>
  <xsl:param name="operandIndex" as="xs:integer"/>
  <xsl:param name="attribute" as="xs:integer"/>

  <xsl:template name="generate-operands">
    <xsl:sequence select="//bpel:sequence[count(*) > 1 and 
    not(.//(bpel:receive | bpel:pick)[@createInstance = 'yes'] or 
    ./ancestor::bpel:scope[@isolated='yes'])]"/>
  </xsl:template>

  <xsl:template match="bpel:sequence" mode="mutate-node">
    <bpel:flow>
      <xsl:copy-of select="@*|node()"/>
    </bpel:flow>
  </xsl:template>

</xsl:stylesheet>